/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@angular/animations"),require("@angular/cdk/portal"),require("@angular/common"),require("@angular/core"),require("rxjs"),require("@angular/cdk/a11y"),require("@angular/material/core"),require("@angular/cdk/coercion"),require("@angular/cdk/keycodes"),require("rxjs/operators"),require("@angular/cdk/bidi"),require("@angular/cdk/overlay"),require("@angular/cdk/platform")):"function"==typeof define&&define.amd?define("@angular/material/menu",["exports","@angular/animations","@angular/cdk/portal","@angular/common","@angular/core","rxjs","@angular/cdk/a11y","@angular/material/core","@angular/cdk/coercion","@angular/cdk/keycodes","rxjs/operators","@angular/cdk/bidi","@angular/cdk/overlay","@angular/cdk/platform"],t):t((e.ng=e.ng||{},e.ng.material=e.ng.material||{},e.ng.material.menu={}),e.ng.animations,e.ng.cdk.portal,e.ng.common,e.ng.core,e.rxjs,e.ng.cdk.a11y,e.ng.material.core,e.ng.cdk.coercion,e.ng.cdk.keycodes,e.rxjs.operators,e.ng.cdk.bidi,e.ng.cdk.overlay,e.ng.cdk.platform)}(this,function(e,t,n,i,o,r,s,a,u,c,p,l,m,h){"use strict";function d(e,t){function n(){this.constructor=e}v(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}function g(){throw Error('matMenuTriggerFor: must pass in an mat-menu instance.\n\n    Example:\n      <mat-menu #menu="matMenu"></mat-menu>\n      <button [matMenuTriggerFor]="menu"></button>')}function f(){throw Error('xPosition value must be either \'before\' or after\'.\n      Example: <mat-menu xPosition="before" #menu="matMenu"></mat-menu>')}function _(){throw Error('yPosition value must be either \'above\' or below\'.\n      Example: <mat-menu yPosition="above" #menu="matMenu"></mat-menu>')}function y(){return{overlapTrigger:!1,xPosition:"after",yPosition:"below",backdropClass:"cdk-overlay-transparent-backdrop"}}function b(e){return function(){return e.scrollStrategies.reposition()}}var v=function(e,t){return(v=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},M={transformMenu:t.trigger("transformMenu",[t.state("void",t.style({opacity:0,transform:"scale(0.8)"})),t.transition("void => enter",t.group([t.query(".mat-menu-content, .mat-mdc-menu-content",t.animate("100ms linear",t.style({opacity:1}))),t.animate("120ms cubic-bezier(0, 0, 0.2, 1)",t.style({transform:"scale(1)"}))])),t.transition("* => void",t.animate("100ms 25ms linear",t.style({opacity:0})))]),fadeInItems:t.trigger("fadeInItems",[t.state("showing",t.style({opacity:1})),t.transition("void => *",[t.style({opacity:0}),t.animate("400ms 100ms cubic-bezier(0.55, 0, 0.55, 0.2)")])])},k=M.fadeInItems,O=M.transformMenu,C=function(){function e(e,t,n,i,o,s,a){this._template=e,this._componentFactoryResolver=t,this._appRef=n,this._injector=i,this._viewContainerRef=o,this._document=s,this._changeDetectorRef=a,this._attached=new r.Subject}return e.prototype.attach=function(e){void 0===e&&(e={}),this._portal||(this._portal=new n.TemplatePortal(this._template,this._viewContainerRef)),this.detach(),this._outlet||(this._outlet=new n.DomPortalOutlet(this._document.createElement("div"),this._componentFactoryResolver,this._appRef,this._injector));var t=this._template.elementRef.nativeElement;t.parentNode.insertBefore(this._outlet.outletElement,t),this._changeDetectorRef&&this._changeDetectorRef.markForCheck(),this._portal.attach(this._outlet,e),this._attached.next()},e.prototype.detach=function(){this._portal.isAttached&&this._portal.detach()},e.prototype.ngOnDestroy=function(){this._outlet&&this._outlet.dispose()},e.decorators=[{type:o.Directive,args:[{selector:"ng-template[matMenuContent]"}]}],e.ctorParameters=function(){return[{type:o.TemplateRef},{type:o.ComponentFactoryResolver},{type:o.ApplicationRef},{type:o.Injector},{type:o.ViewContainerRef},{type:void 0,decorators:[{type:o.Inject,args:[i.DOCUMENT]}]},{type:o.ChangeDetectorRef}]},e}(),I=new o.InjectionToken("MAT_MENU_PANEL"),P=function(){function e(){}return e}(),x=a.mixinDisableRipple(a.mixinDisabled(P)),w=function(e){function t(t,n,i,o){var s=e.call(this)||this;return s._elementRef=t,s._focusMonitor=i,s._parentMenu=o,s.role="menuitem",s._hovered=new r.Subject,s._highlighted=!1,s._triggersSubmenu=!1,i&&i.monitor(s._elementRef,!1),o&&o.addItem&&o.addItem(s),s._document=n,s}return d(t,e),t.prototype.focus=function(e,t){void 0===e&&(e="program"),this._focusMonitor?this._focusMonitor.focusVia(this._getHostElement(),e,t):this._getHostElement().focus(t)},t.prototype.ngOnDestroy=function(){this._focusMonitor&&this._focusMonitor.stopMonitoring(this._elementRef),this._parentMenu&&this._parentMenu.removeItem&&this._parentMenu.removeItem(this),this._hovered.complete()},t.prototype._getTabIndex=function(){return this.disabled?"-1":"0"},t.prototype._getHostElement=function(){return this._elementRef.nativeElement},t.prototype._checkDisabled=function(e){this.disabled&&(e.preventDefault(),e.stopPropagation())},t.prototype._handleMouseEnter=function(){this._hovered.next(this)},t.prototype.getLabel=function(){var e=this._elementRef.nativeElement,t=this._document?this._document.TEXT_NODE:3,n="";if(e.childNodes)for(var i=e.childNodes.length,o=0;o<i;o++)e.childNodes[o].nodeType===t&&(n+=e.childNodes[o].textContent);return n.trim()},t.decorators=[{type:o.Component,args:[{selector:"[mat-menu-item]",exportAs:"matMenuItem",inputs:["disabled","disableRipple"],host:{"[attr.role]":"role",class:"mat-menu-item","[class.mat-menu-item-highlighted]":"_highlighted","[class.mat-menu-item-submenu-trigger]":"_triggersSubmenu","[attr.tabindex]":"_getTabIndex()","[attr.aria-disabled]":"disabled.toString()","[attr.disabled]":"disabled || null"},changeDetection:o.ChangeDetectionStrategy.OnPush,encapsulation:o.ViewEncapsulation.None,template:'<ng-content></ng-content><div class="mat-menu-ripple" matRipple [matRippleDisabled]="disableRipple || disabled" [matRippleTrigger]="_getHostElement()"></div>'}]}],t.ctorParameters=function(){return[{type:o.ElementRef},{type:void 0,decorators:[{type:o.Inject,args:[i.DOCUMENT]}]},{type:s.FocusMonitor},{type:void 0,decorators:[{type:o.Inject,args:[I]},{type:o.Optional}]}]},t.propDecorators={role:[{type:o.Input}],_checkDisabled:[{type:o.HostListener,args:["click",["$event"]]}],_handleMouseEnter:[{type:o.HostListener,args:["mouseenter"]}]},t}(x),E=new o.InjectionToken("mat-menu-default-options",{providedIn:"root",factory:y}),R=function(){function e(e,t,n){this._elementRef=e,this._ngZone=t,this._defaultOptions=n,this._xPosition=this._defaultOptions.xPosition,this._yPosition=this._defaultOptions.yPosition,this._directDescendantItems=new o.QueryList,this._tabSubscription=r.Subscription.EMPTY,this._classList={},this._panelAnimationState="void",this._animationDone=new r.Subject,this.backdropClass=this._defaultOptions.backdropClass,this._overlapTrigger=this._defaultOptions.overlapTrigger,this._hasBackdrop=this._defaultOptions.hasBackdrop,this.closed=new o.EventEmitter,this.close=this.closed}return Object.defineProperty(e.prototype,"xPosition",{get:function(){return this._xPosition},set:function(e){"before"!==e&&"after"!==e&&f(),this._xPosition=e,this.setPositionClasses()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"yPosition",{get:function(){return this._yPosition},set:function(e){"above"!==e&&"below"!==e&&_(),this._yPosition=e,this.setPositionClasses()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"overlapTrigger",{get:function(){return this._overlapTrigger},set:function(e){this._overlapTrigger=u.coerceBooleanProperty(e)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"hasBackdrop",{get:function(){return this._hasBackdrop},set:function(e){this._hasBackdrop=u.coerceBooleanProperty(e)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"panelClass",{set:function(e){var t=this,n=this._previousPanelClass;n&&n.length&&n.split(" ").forEach(function(e){t._classList[e]=!1}),this._previousPanelClass=e,e&&e.length&&(e.split(" ").forEach(function(e){t._classList[e]=!0}),this._elementRef.nativeElement.className="")},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"classList",{get:function(){return this.panelClass},set:function(e){this.panelClass=e},enumerable:!0,configurable:!0}),e.prototype.ngOnInit=function(){this.setPositionClasses()},e.prototype.ngAfterContentInit=function(){var e=this;this._updateDirectDescendants(),this._keyManager=new s.FocusKeyManager(this._directDescendantItems).withWrap().withTypeAhead(),this._tabSubscription=this._keyManager.tabOut.subscribe(function(){return e.closed.emit("tab")})},e.prototype.ngOnDestroy=function(){this._directDescendantItems.destroy(),this._tabSubscription.unsubscribe(),this.closed.complete()},e.prototype._hovered=function(){return this._directDescendantItems.changes.pipe(p.startWith(this._directDescendantItems),p.switchMap(function(e){return r.merge.apply(void 0,e.map(function(e){return e._hovered}))}))},e.prototype.addItem=function(e){},e.prototype.removeItem=function(e){},e.prototype._handleKeydown=function(e){var t=e.keyCode,n=this._keyManager;switch(t){case c.ESCAPE:c.hasModifierKey(e)||(e.preventDefault(),this.closed.emit("keydown"));break;case c.LEFT_ARROW:this.parentMenu&&"ltr"===this.direction&&this.closed.emit("keydown");break;case c.RIGHT_ARROW:this.parentMenu&&"rtl"===this.direction&&this.closed.emit("keydown");break;case c.HOME:case c.END:c.hasModifierKey(e)||(t===c.HOME?n.setFirstItemActive():n.setLastItemActive(),e.preventDefault());break;default:t!==c.UP_ARROW&&t!==c.DOWN_ARROW||n.setFocusOrigin("keyboard"),n.onKeydown(e)}},e.prototype.focusFirstItem=function(e){var t=this;void 0===e&&(e="program"),this.lazyContent?this._ngZone.onStable.asObservable().pipe(p.take(1)).subscribe(function(){return t._keyManager.setFocusOrigin(e).setFirstItemActive()}):this._keyManager.setFocusOrigin(e).setFirstItemActive()},e.prototype.resetActiveItem=function(){this._keyManager.setActiveItem(-1)},e.prototype.setElevation=function(e){var t="mat-elevation-z"+(4+e),n=Object.keys(this._classList).find(function(e){return e.startsWith("mat-elevation-z")});n&&n!==this._previousElevation||(this._previousElevation&&(this._classList[this._previousElevation]=!1),this._classList[t]=!0,this._previousElevation=t)},e.prototype.setPositionClasses=function(e,t){void 0===e&&(e=this.xPosition),void 0===t&&(t=this.yPosition);var n=this._classList;n["mat-menu-before"]="before"===e,n["mat-menu-after"]="after"===e,n["mat-menu-above"]="above"===t,n["mat-menu-below"]="below"===t},e.prototype._startAnimation=function(){this._panelAnimationState="enter"},e.prototype._resetAnimation=function(){this._panelAnimationState="void"},e.prototype._onAnimationDone=function(e){this._animationDone.next(e),this._isAnimating=!1},e.prototype._onAnimationStart=function(e){this._isAnimating=!0,"enter"===e.toState&&0===this._keyManager.activeItemIndex&&(e.element.scrollTop=0)},e.prototype._updateDirectDescendants=function(){var e=this;this._allItems.changes.pipe(p.startWith(this._allItems)).subscribe(function(t){e._directDescendantItems.reset(t.filter(function(t){return t._parentMenu===e})),e._directDescendantItems.notifyOnChanges()})},e.ctorParameters=function(){return[{type:o.ElementRef},{type:o.NgZone},{type:void 0,decorators:[{type:o.Inject,args:[E]}]}]},e.propDecorators={_allItems:[{type:o.ContentChildren,args:[w,{descendants:!0}]}],backdropClass:[{type:o.Input}],xPosition:[{type:o.Input}],yPosition:[{type:o.Input}],templateRef:[{type:o.ViewChild,args:[o.TemplateRef,{static:!1}]}],items:[{type:o.ContentChildren,args:[w]}],lazyContent:[{type:o.ContentChild,args:[C,{static:!1}]}],overlapTrigger:[{type:o.Input}],hasBackdrop:[{type:o.Input}],panelClass:[{type:o.Input,args:["class"]}],classList:[{type:o.Input}],closed:[{type:o.Output}],close:[{type:o.Output}]},e}(),S=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return d(t,e),t}(R),T=function(e){function t(t,n,i){return e.call(this,t,n,i)||this}return d(t,e),t.decorators=[{type:o.Component,args:[{selector:"mat-menu",template:'<ng-template><div class="mat-menu-panel" [ngClass]="_classList" (keydown)="_handleKeydown($event)" (click)="closed.emit(\'click\')" [@transformMenu]="_panelAnimationState" (@transformMenu.start)="_onAnimationStart($event)" (@transformMenu.done)="_onAnimationDone($event)" tabindex="-1" role="menu"><div class="mat-menu-content"><ng-content></ng-content></div></div></ng-template>',styles:[".mat-menu-panel{min-width:112px;max-width:280px;overflow:auto;-webkit-overflow-scrolling:touch;max-height:calc(100vh - 48px);border-radius:4px;outline:0;min-height:64px}.mat-menu-panel.ng-animating{pointer-events:none}@media (-ms-high-contrast:active){.mat-menu-panel{outline:solid 1px}}.mat-menu-content:not(:empty){padding-top:8px;padding-bottom:8px}.mat-menu-item{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:pointer;outline:0;border:none;-webkit-tap-highlight-color:transparent;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;line-height:48px;height:48px;padding:0 16px;text-align:left;text-decoration:none;max-width:100%;position:relative}.mat-menu-item::-moz-focus-inner{border:0}.mat-menu-item[disabled]{cursor:default}[dir=rtl] .mat-menu-item{text-align:right}.mat-menu-item .mat-icon{margin-right:16px;vertical-align:middle}.mat-menu-item .mat-icon svg{vertical-align:top}[dir=rtl] .mat-menu-item .mat-icon{margin-left:16px;margin-right:0}.mat-menu-item[disabled]{pointer-events:none}@media (-ms-high-contrast:active){.mat-menu-item-highlighted,.mat-menu-item.cdk-keyboard-focused,.mat-menu-item.cdk-program-focused{outline:dotted 1px}}.mat-menu-item-submenu-trigger{padding-right:32px}.mat-menu-item-submenu-trigger::after{width:0;height:0;border-style:solid;border-width:5px 0 5px 5px;border-color:transparent transparent transparent currentColor;content:'';display:inline-block;position:absolute;top:50%;right:16px;transform:translateY(-50%)}[dir=rtl] .mat-menu-item-submenu-trigger{padding-right:16px;padding-left:32px}[dir=rtl] .mat-menu-item-submenu-trigger::after{right:auto;left:16px;transform:rotateY(180deg) translateY(-50%)}button.mat-menu-item{width:100%}.mat-menu-item .mat-menu-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none}"],changeDetection:o.ChangeDetectionStrategy.OnPush,encapsulation:o.ViewEncapsulation.None,exportAs:"matMenu",animations:[M.transformMenu,M.fadeInItems],providers:[{provide:I,useExisting:S},{provide:S,useExisting:t}]}]}],t.ctorParameters=function(){return[{type:o.ElementRef},{type:o.NgZone},{type:void 0,decorators:[{type:o.Inject,args:[E]}]}]},t}(S),D=new o.InjectionToken("mat-menu-scroll-strategy"),A={provide:D,deps:[m.Overlay],useFactory:b},j=h.normalizePassiveListenerOptions({passive:!0}),F=function(){function e(e,t,n,i,s,a,u,c){var p=this;this._overlay=e,this._element=t,this._viewContainerRef=n,this._parentMenu=s,this._menuItemInstance=a,this._dir=u,this._focusMonitor=c,this._overlayRef=null,this._menuOpen=!1,this._closingActionsSubscription=r.Subscription.EMPTY,this._hoverSubscription=r.Subscription.EMPTY,this._menuCloseSubscription=r.Subscription.EMPTY,this._handleTouchStart=function(){return p._openedBy="touch"},this._openedBy=null,this.restoreFocus=!0,this.menuOpened=new o.EventEmitter,this.onMenuOpen=this.menuOpened,this.menuClosed=new o.EventEmitter,this.onMenuClose=this.menuClosed,t.nativeElement.addEventListener("touchstart",this._handleTouchStart,j),a&&(a._triggersSubmenu=this.triggersSubmenu()),this._scrollStrategy=i}return Object.defineProperty(e.prototype,"_deprecatedMatMenuTriggerFor",{get:function(){return this.menu},set:function(e){this.menu=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"menu",{get:function(){return this._menu},set:function(e){var t=this;e!==this._menu&&(this._menu=e,this._menuCloseSubscription.unsubscribe(),e&&(this._menuCloseSubscription=e.close.asObservable().subscribe(function(e){t._destroyMenu(),"click"!==e&&"tab"!==e||!t._parentMenu||t._parentMenu.closed.emit(e)})))},enumerable:!0,configurable:!0}),e.prototype.ngAfterContentInit=function(){this._checkMenu(),this._handleHover()},e.prototype.ngOnDestroy=function(){this._overlayRef&&(this._overlayRef.dispose(),this._overlayRef=null),this._element.nativeElement.removeEventListener("touchstart",this._handleTouchStart,j),this._menuCloseSubscription.unsubscribe(),this._closingActionsSubscription.unsubscribe(),this._hoverSubscription.unsubscribe()},Object.defineProperty(e.prototype,"menuOpen",{get:function(){return this._menuOpen},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"dir",{get:function(){return this._dir&&"rtl"===this._dir.value?"rtl":"ltr"},enumerable:!0,configurable:!0}),e.prototype.triggersSubmenu=function(){return!(!this._menuItemInstance||!this._parentMenu)},e.prototype.toggleMenu=function(){return this._menuOpen?this.closeMenu():this.openMenu()},e.prototype.openMenu=function(){var e=this;if(!this._menuOpen){this._checkMenu();var t=this._createOverlay(),n=t.getConfig();this._setPosition(n.positionStrategy),n.hasBackdrop=null==this.menu.hasBackdrop?!this.triggersSubmenu():this.menu.hasBackdrop,t.attach(this._getPortal()),this.menu.lazyContent&&this.menu.lazyContent.attach(this.menuData),this._closingActionsSubscription=this._menuClosingActions().subscribe(function(){return e.closeMenu()}),this._initMenu(),this.menu instanceof S&&this.menu._startAnimation()}},e.prototype.closeMenu=function(){this.menu.close.emit()},e.prototype.focus=function(e,t){void 0===e&&(e="program"),this._focusMonitor?this._focusMonitor.focusVia(this._element,e,t):this._element.nativeElement.focus(t)},e.prototype._destroyMenu=function(){var e=this;if(this._overlayRef&&this.menuOpen){var t=this.menu;this._closingActionsSubscription.unsubscribe(),this._overlayRef.detach(),t instanceof S?(t._resetAnimation(),t.lazyContent?t._animationDone.pipe(p.filter(function(e){return"void"===e.toState}),p.take(1),p.takeUntil(t.lazyContent._attached)).subscribe({next:function(){return t.lazyContent.detach()},complete:function(){return e._resetMenu()}}):this._resetMenu()):(this._resetMenu(),t.lazyContent&&t.lazyContent.detach())}},e.prototype._initMenu=function(){this.menu.parentMenu=this.triggersSubmenu()?this._parentMenu:void 0,this.menu.direction=this.dir,this._setMenuElevation(),this._setIsMenuOpen(!0),this.menu.focusFirstItem(this._openedBy||"program")},e.prototype._setMenuElevation=function(){if(this.menu.setElevation){for(var e=0,t=this.menu.parentMenu;t;)e++,t=t.parentMenu;this.menu.setElevation(e)}},e.prototype._resetMenu=function(){this._setIsMenuOpen(!1),this.restoreFocus&&(this._openedBy?this.triggersSubmenu()||this.focus(this._openedBy):this.focus()),this._openedBy=null},e.prototype._setIsMenuOpen=function(e){this._menuOpen=e,this._menuOpen?this.menuOpened.emit():this.menuClosed.emit(),this.triggersSubmenu()&&(this._menuItemInstance._highlighted=e)},e.prototype._checkMenu=function(){this.menu||g()},e.prototype._createOverlay=function(){if(!this._overlayRef){var e=this._getOverlayConfig();this._subscribeToPositions(e.positionStrategy),this._overlayRef=this._overlay.create(e),this._overlayRef.keydownEvents().subscribe()}return this._overlayRef},e.prototype._getOverlayConfig=function(){return new m.OverlayConfig({positionStrategy:this._overlay.position().flexibleConnectedTo(this._element).withLockedPosition().withTransformOriginOn(".mat-menu-panel, .mat-mdc-menu-panel"),backdropClass:this.menu.backdropClass||"cdk-overlay-transparent-backdrop",scrollStrategy:this._scrollStrategy(),direction:this._dir})},e.prototype._subscribeToPositions=function(e){var t=this;this.menu.setPositionClasses&&e.positionChanges.subscribe(function(e){var n="start"===e.connectionPair.overlayX?"after":"before",i="top"===e.connectionPair.overlayY?"below":"above";t.menu.setPositionClasses(n,i)})},e.prototype._setPosition=function(e){var t="before"===this.menu.xPosition?["end","start"]:["start","end"],n=t[0],i=t[1],o="above"===this.menu.yPosition?["bottom","top"]:["top","bottom"],r=o[0],s=o[1],a=[r,s],u=a[0],c=a[1],p=[n,i],l=p[0],m=p[1],h=0;this.triggersSubmenu()?(m=n="before"===this.menu.xPosition?"start":"end",i=l="end"===n?"start":"end",h="bottom"===r?8:-8):this.menu.overlapTrigger||(u="top"===r?"bottom":"top",c="top"===s?"bottom":"top"),e.withPositions([{originX:n,originY:u,overlayX:l,overlayY:r,offsetY:h},{originX:i,originY:u,overlayX:m,overlayY:r,offsetY:h},{originX:n,originY:c,overlayX:l,overlayY:s,offsetY:-h},{originX:i,originY:c,overlayX:m,overlayY:s,offsetY:-h}])},e.prototype._menuClosingActions=function(){var e=this,t=this._overlayRef.backdropClick(),n=this._overlayRef.detachments(),i=this._parentMenu?this._parentMenu.closed:r.of(),o=this._parentMenu?this._parentMenu._hovered().pipe(p.filter(function(t){return t!==e._menuItemInstance}),p.filter(function(){return e._menuOpen})):r.of();return r.merge(t,i,o,n)},e.prototype._handleMousedown=function(e){s.isFakeMousedownFromScreenReader(e)||(this._openedBy=0===e.button?"mouse":null,this.triggersSubmenu()&&e.preventDefault())},e.prototype._handleKeydown=function(e){var t=e.keyCode;this.triggersSubmenu()&&(t===c.RIGHT_ARROW&&"ltr"===this.dir||t===c.LEFT_ARROW&&"rtl"===this.dir)&&this.openMenu()},e.prototype._handleClick=function(e){this.triggersSubmenu()?(e.stopPropagation(),this.openMenu()):this.toggleMenu()},e.prototype._handleHover=function(){var e=this;this.triggersSubmenu()&&(this._hoverSubscription=this._parentMenu._hovered().pipe(p.filter(function(t){return t===e._menuItemInstance&&!t.disabled}),p.delay(0,r.asapScheduler)).subscribe(function(){e._openedBy="mouse",e.menu instanceof S&&e.menu._isAnimating?e.menu._animationDone.pipe(p.take(1),p.delay(0,r.asapScheduler),p.takeUntil(e._parentMenu._hovered())).subscribe(function(){return e.openMenu()}):e.openMenu()}))},e.prototype._getPortal=function(){return this._portal&&this._portal.templateRef===this.menu.templateRef||(this._portal=new n.TemplatePortal(this.menu.templateRef,this._viewContainerRef)),this._portal},e.decorators=[{type:o.Directive,args:[{selector:"[mat-menu-trigger-for], [matMenuTriggerFor]",host:{class:"mat-menu-trigger","aria-haspopup":"true","[attr.aria-expanded]":"menuOpen || null","(mousedown)":"_handleMousedown($event)","(keydown)":"_handleKeydown($event)","(click)":"_handleClick($event)"},exportAs:"matMenuTrigger"}]}],e.ctorParameters=function(){return[{type:m.Overlay},{type:o.ElementRef},{type:o.ViewContainerRef},{type:void 0,decorators:[{type:o.Inject,args:[D]}]},{type:S,decorators:[{type:o.Optional}]},{type:w,decorators:[{type:o.Optional},{type:o.Self}]},{type:l.Directionality,decorators:[{type:o.Optional}]},{type:s.FocusMonitor}]},e.propDecorators={_deprecatedMatMenuTriggerFor:[{type:o.Input,args:["mat-menu-trigger-for"]}],menu:[{type:o.Input,args:["matMenuTriggerFor"]}],menuData:[{type:o.Input,args:["matMenuTriggerData"]}],restoreFocus:[{type:o.Input,args:["matMenuTriggerRestoreFocus"]}],menuOpened:[{type:o.Output}],onMenuOpen:[{type:o.Output}],menuClosed:[{type:o.Output}],onMenuClose:[{type:o.Output}]},e}(),L=function(){function e(){}return e.decorators=[{type:o.NgModule,args:[{exports:[F,C,a.MatCommonModule],declarations:[F,C],providers:[A]}]}],e}(),N=function(){function e(){}return e.decorators=[{type:o.NgModule,args:[{imports:[i.CommonModule,a.MatCommonModule,a.MatRippleModule,m.OverlayModule,L],exports:[T,w,L],declarations:[T,w],providers:[A]}]}],e}();e.MatMenu=S,e.MAT_MENU_DEFAULT_OPTIONS=E,e._MatMenu=T,e._MatMenuBase=R,e.MatMenuItem=w,e.MatMenuTrigger=F,e.MAT_MENU_SCROLL_STRATEGY=D,e.MAT_MENU_PANEL=I,e._MatMenuDirectivesModule=L,e.MatMenuModule=N,e.matMenuAnimations=M,e.fadeInItems=k,e.transformMenu=O,e.MatMenuContent=C,e.ɵa24=y,e.ɵb24=b,e.ɵc24=A,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=material-menu.umd.min.js.map
