/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
!function(r,a){"object"==typeof exports&&"undefined"!=typeof module?a(exports,require("@angular/core"),require("rxjs"),require("rxjs/operators"),require("@angular/platform-browser/animations"),require("@angular/material/core"),require("@angular/common")):"function"==typeof define&&define.amd?define("@angular/material/progress-bar",["exports","@angular/core","rxjs","rxjs/operators","@angular/platform-browser/animations","@angular/material/core","@angular/common"],a):a((r.ng=r.ng||{},r.ng.material=r.ng.material||{},r.ng.material.progressBar={}),r.ng.core,r.rxjs,r.rxjs.operators,r.ng.platformBrowser.animations,r.ng.material.core,r.ng.common)}(this,function(r,a,e,t,n,i,o){"use strict";function s(r,a){function e(){this.constructor=r}l(r,a),r.prototype=null===a?Object.create(a):(e.prototype=a.prototype,new e)}function m(){var r=a.inject(o.DOCUMENT),e=r?r.location:null;return{getPathname:function(){return e?e.pathname+e.search:""}}}function p(r,a,e){return void 0===a&&(a=0),void 0===e&&(e=100),Math.max(a,Math.min(e,r))}var l=function(r,a){return(l=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(r,a){r.__proto__=a}||function(r,a){for(var e in a)a.hasOwnProperty(e)&&(r[e]=a[e])})(r,a)},b=function(){function r(r){this._elementRef=r}return r}(),c=i.mixinColor(b,"primary"),f=new a.InjectionToken("mat-progress-bar-location",{providedIn:"root",factory:m}),g=0,u=function(r){function i(t,n,i,o){var s=r.call(this,t)||this;s._elementRef=t,s._ngZone=n,s._animationMode=i,s._isNoopAnimation=!1,s._value=0,s._bufferValue=0,s.animationEnd=new a.EventEmitter,s._animationEndSubscription=e.Subscription.EMPTY,s.mode="determinate",s.progressbarId="mat-progress-bar-"+g++;var m=o?o.getPathname().split("#")[0]:"";return s._rectangleFillValue="url('"+m+"#"+s.progressbarId+"')",s._isNoopAnimation="NoopAnimations"===i,s}return s(i,r),Object.defineProperty(i.prototype,"value",{get:function(){return this._value},set:function(r){this._value=p(r||0),this._isNoopAnimation&&this._emitAnimationEnd()},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"bufferValue",{get:function(){return this._bufferValue},set:function(r){this._bufferValue=p(r||0)},enumerable:!0,configurable:!0}),i.prototype._primaryTransform=function(){return{transform:"scaleX("+this.value/100+")"}},i.prototype._bufferTransform=function(){if("buffer"===this.mode){return{transform:"scaleX("+this.bufferValue/100+")"}}},i.prototype.ngAfterViewInit=function(){var r=this;this._isNoopAnimation||this._ngZone.runOutsideAngular(function(){var a=r._primaryValueBar.nativeElement;r._animationEndSubscription=e.fromEvent(a,"transitionend").pipe(t.filter(function(r){return r.target===a})).subscribe(function(){return r._ngZone.run(function(){return r._emitAnimationEnd()})})})},i.prototype.ngOnDestroy=function(){this._animationEndSubscription.unsubscribe()},i.prototype._emitAnimationEnd=function(){"determinate"!==this.mode&&"buffer"!==this.mode||this.animationEnd.next({value:this.value})},i.decorators=[{type:a.Component,args:[{selector:"mat-progress-bar",exportAs:"matProgressBar",host:{role:"progressbar","aria-valuemin":"0","aria-valuemax":"100","[attr.aria-valuenow]":'(mode === "indeterminate" || mode === "query") ? null : value',"[attr.mode]":"mode",class:"mat-progress-bar","[class._mat-animation-noopable]":"_isNoopAnimation"},inputs:["color"],template:'<svg width="100%" height="4" focusable="false" class="mat-progress-bar-background mat-progress-bar-element"><defs><pattern [id]="progressbarId" x="4" y="0" width="8" height="4" patternUnits="userSpaceOnUse"><circle cx="2" cy="2" r="2"/></pattern></defs><rect [attr.fill]="_rectangleFillValue" width="100%" height="100%"/></svg><div class="mat-progress-bar-buffer mat-progress-bar-element" [ngStyle]="_bufferTransform()"></div><div class="mat-progress-bar-primary mat-progress-bar-fill mat-progress-bar-element" [ngStyle]="_primaryTransform()" #primaryValueBar></div><div class="mat-progress-bar-secondary mat-progress-bar-fill mat-progress-bar-element"></div>',styles:[".mat-progress-bar{display:block;height:4px;overflow:hidden;position:relative;transition:opacity 250ms linear;width:100%}._mat-animation-noopable.mat-progress-bar{transition:none;animation:none}.mat-progress-bar .mat-progress-bar-element,.mat-progress-bar .mat-progress-bar-fill::after{height:100%;position:absolute;width:100%}.mat-progress-bar .mat-progress-bar-background{width:calc(100% + 10px)}@media (-ms-high-contrast:active){.mat-progress-bar .mat-progress-bar-background{display:none}}.mat-progress-bar .mat-progress-bar-buffer{transform-origin:top left;transition:transform 250ms ease}@media (-ms-high-contrast:active){.mat-progress-bar .mat-progress-bar-buffer{border-top:solid 5px;opacity:.5}}.mat-progress-bar .mat-progress-bar-secondary{display:none}.mat-progress-bar .mat-progress-bar-fill{animation:none;transform-origin:top left;transition:transform 250ms ease}@media (-ms-high-contrast:active){.mat-progress-bar .mat-progress-bar-fill{border-top:solid 4px}}.mat-progress-bar .mat-progress-bar-fill::after{animation:none;content:'';display:inline-block;left:0}.mat-progress-bar[dir=rtl],[dir=rtl] .mat-progress-bar{transform:rotateY(180deg)}.mat-progress-bar[mode=query]{transform:rotateZ(180deg)}.mat-progress-bar[mode=query][dir=rtl],[dir=rtl] .mat-progress-bar[mode=query]{transform:rotateZ(180deg) rotateY(180deg)}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-fill,.mat-progress-bar[mode=query] .mat-progress-bar-fill{transition:none}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-primary,.mat-progress-bar[mode=query] .mat-progress-bar-primary{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-primary-indeterminate-translate 2s infinite linear;left:-145.166611%}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-primary.mat-progress-bar-fill::after,.mat-progress-bar[mode=query] .mat-progress-bar-primary.mat-progress-bar-fill::after{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-primary-indeterminate-scale 2s infinite linear}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-secondary,.mat-progress-bar[mode=query] .mat-progress-bar-secondary{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-secondary-indeterminate-translate 2s infinite linear;left:-54.888891%;display:block}.mat-progress-bar[mode=indeterminate] .mat-progress-bar-secondary.mat-progress-bar-fill::after,.mat-progress-bar[mode=query] .mat-progress-bar-secondary.mat-progress-bar-fill::after{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-secondary-indeterminate-scale 2s infinite linear}.mat-progress-bar[mode=buffer] .mat-progress-bar-background{-webkit-backface-visibility:hidden;backface-visibility:hidden;animation:mat-progress-bar-background-scroll 250ms infinite linear;display:block}.mat-progress-bar._mat-animation-noopable .mat-progress-bar-background,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-buffer,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-fill,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-fill::after,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-primary,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-primary.mat-progress-bar-fill::after,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-secondary,.mat-progress-bar._mat-animation-noopable .mat-progress-bar-secondary.mat-progress-bar-fill::after{animation:none;transition:none}@keyframes mat-progress-bar-primary-indeterminate-translate{0%{transform:translateX(0)}20%{animation-timing-function:cubic-bezier(.5,0,.70173,.49582);transform:translateX(0)}59.15%{animation-timing-function:cubic-bezier(.30244,.38135,.55,.95635);transform:translateX(83.67142%)}100%{transform:translateX(200.61106%)}}@keyframes mat-progress-bar-primary-indeterminate-scale{0%{transform:scaleX(.08)}36.65%{animation-timing-function:cubic-bezier(.33473,.12482,.78584,1);transform:scaleX(.08)}69.15%{animation-timing-function:cubic-bezier(.06,.11,.6,1);transform:scaleX(.66148)}100%{transform:scaleX(.08)}}@keyframes mat-progress-bar-secondary-indeterminate-translate{0%{animation-timing-function:cubic-bezier(.15,0,.51506,.40969);transform:translateX(0)}25%{animation-timing-function:cubic-bezier(.31033,.28406,.8,.73371);transform:translateX(37.65191%)}48.35%{animation-timing-function:cubic-bezier(.4,.62704,.6,.90203);transform:translateX(84.38617%)}100%{transform:translateX(160.27778%)}}@keyframes mat-progress-bar-secondary-indeterminate-scale{0%{animation-timing-function:cubic-bezier(.15,0,.51506,.40969);transform:scaleX(.08)}19.15%{animation-timing-function:cubic-bezier(.31033,.28406,.8,.73371);transform:scaleX(.4571)}44.15%{animation-timing-function:cubic-bezier(.4,.62704,.6,.90203);transform:scaleX(.72796)}100%{transform:scaleX(.08)}}@keyframes mat-progress-bar-background-scroll{to{transform:translateX(-8px)}}"],changeDetection:a.ChangeDetectionStrategy.OnPush,encapsulation:a.ViewEncapsulation.None}]}],i.ctorParameters=function(){return[{type:a.ElementRef},{type:a.NgZone},{type:String,decorators:[{type:a.Optional},{type:a.Inject,args:[n.ANIMATION_MODULE_TYPE]}]},{type:void 0,decorators:[{type:a.Optional},{type:a.Inject,args:[f]}]}]},i.propDecorators={value:[{type:a.Input}],bufferValue:[{type:a.Input}],_primaryValueBar:[{type:a.ViewChild,args:["primaryValueBar",{static:!1}]}],animationEnd:[{type:a.Output}],mode:[{type:a.Input}]},i}(c),d=function(){function r(){}return r.decorators=[{type:a.NgModule,args:[{imports:[o.CommonModule,i.MatCommonModule],exports:[u,i.MatCommonModule],declarations:[u]}]}],r}();r.MatProgressBarModule=d,r.MAT_PROGRESS_BAR_LOCATION_FACTORY=m,r.MAT_PROGRESS_BAR_LOCATION=f,r.MatProgressBar=u,Object.defineProperty(r,"__esModule",{value:!0})});
//# sourceMappingURL=material-progress-bar.umd.min.js.map
